#ifndef __ZX_MODIFIES_H_
#define __ZX_MODIFIES_H_

/*this piece code should be place in drm/drm-fourcc.h in kernel/mesa*/

#include <drm/drm_fourcc.h>
#define DRM_FORMAT_MOD_VENDOR_ZX 0x19
/*usage  for display specially requirement*/
#define DRM_FORMAT_MOD_ZX_DISPLAY               fourcc_mod_code(ZX, 1)
#define DRM_FORMAT_MOD_ZX_LINEAR                fourcc_mod_code(ZX, 2)
#define DRM_FORMAT_MOD_ZX_TILED                 fourcc_mod_code(ZX, 3)
#define DRM_FORMAT_MOD_ZX_COMPRESS              fourcc_mod_code(ZX, 4)
#define DRM_FORMAT_MOD_ZX_TILED_COMPRESS        fourcc_mod_code(ZX, 5)


#define DRM_FORMAT_MOD_ZX_LOCAL                 fourcc_mod_code(ZX, 6)
#define DRM_FORMAT_MOD_ZX_PCIE                  fourcc_mod_code(ZX, 7)

#define DRM_FORMAT_MOD_ZX_INVALID               fourcc_mod_code(ZX, 119)
#endif

